World [
	title:	"Virtuel ARP2500"
	author:	"John Niclasen"
]


do %GARPview.w


world-debug: make function! [[
][
	;probe GARPview/textures
	exit
]]


G2500: make context! [


set 'stylize make function! [[
	vobs	[handle!]
	name	[handle!]
][
	GARPview-stylize
		to block! read join %modules/ to lit-string! name
		vobs
	exit
]]


set 'layout-vob make function! [[
	vob		[handle!]
	name	[handle!]
][
	;GARPview-layout load join %modules/ to lit-string! name vob
	GARPview-layout
		to block! read join %modules/ to lit-string! name
		vob
	exit
]]


texture-image: make struct! [[
	pointer	image
] none]
;images: []


set 'get-texture make function! [[
	texture	[integer!]
	ptr		[handle!]
][
	ptr: as texture-image ptr
	;ptr: retain as texture-image ptr	; TODO how to free it?

	ptr/image: pick GARPview/textures texture
	;insert images retain copy pick GARPview/textures texture
	;ptr/image: images/1

	;ptr: as [vector! pointer 1] ptr
	;poke ptr 1 pick GARPview/textures texture
	exit
]]


shader-source: make struct! [[
	pointer	v-code
	pointer	f-code
	uint32	v-shader
	uint32	f-shader
] none]


;sources: []


set 'get-shader make function! [[
	shader	[integer!]
	ptr		[handle!]
][
	ptr: as shader-source ptr	; TODO how to free it?
	ptr/v-shader: GARPview/shader-programs/:shader/1
	ptr/f-shader: GARPview/shader-programs/:shader/2
	ptr/v-code: to lit-string! read to file! pick GARPview/vertex-shaders ptr/v-shader
	ptr/f-code: to lit-string! read to file! pick GARPview/fragment-shaders ptr/f-shader
	exit
]]


set 'get-wire-shader make function! [[
	ptr		[handle!]
][
	ptr: as shader-source ptr
	ptr/v-code: to lit-string! read %shader/line.vert
	ptr/f-code: to lit-string! read %shader/line.frag
	exit
]]


audio-settings: make struct! [[
	sint32	audio-input-device
	sint32	audio-output-device
	sint32	buffer-size
	sint32	MIDI-input-device
] none]
patch: none

G2500-settings: make struct! [[
	pointer	module-types
	pointer	settings
	pointer	skin
	sint32	tooltips
	sint32	zoomdial
	sint32	fullscreen
	sint32	window-x
	sint32	window-y
	sint32	window-w
	sint32	window-h
] none]


pref-path: none
set 'set-pref-path make function! [[
	path	[handle!]
][
	pref-path: to file! to lit-string! path
	exit
]]


set 'get-LKey make function! [[
	v		[handle!]
	/local license-key
][
	v: as [vector! pointer 7] v
	license-key: load join pref-path %LKey.txt
	if any [
		not find license-key 'Title
		string! <> type? license-key/Title
		not find license-key 'Product
		string! <> type? license-key/Product
		not find license-key 'Licensed-to
		;string! <> type? license-key/Licensed-to
		not find any-string! type? license-key/Licensed-to
		not find license-key 'Email
		email! <> type? license-key/Email
		not find license-key 'Serial
		string! <> type? license-key/Serial
		not find license-key 'Date
		string! <> type? license-key/Date
		not find license-key 'Key
		not any-string? license-key/Key
	] [
		;print "fejl"
		poke v 1 '""
		poke v 2 '""
		poke v 3 '""
		poke v 4 '""
		poke v 5 '""
		poke v 6 '""
		poke v 7 '""
		exit
	]
	poke v 1 to lit-string! either 64 > length? license-key/Title [
		license-key/Title
	][
		copy/part license-key/Title 63
	]
	poke v 2 to lit-string! either 64 > length? license-key/Product [
		license-key/Product
	][
		copy/part license-key/Product 63
	]
	poke v 3 to lit-string! either 64 > length? license-key/Licensed-to [
		license-key/Licensed-to
	][
		copy/part license-key/Licensed-to 63
	]
	poke v 4 to lit-string! either 64 > length? license-key/Email [
		either license-key/Email = none@server.net [
			'""
		][
			license-key/Email
		]
	][
		copy/part license-key/Email 63
	]
	poke v 5 to lit-string! either 16 > length? license-key/Serial [
		license-key/Serial
	][
		copy/part license-key/Serial 15
	]
	poke v 6 to lit-string! either 32 > length? license-key/Date [
		license-key/Date
	][
		copy/part license-key/Date 31
	]
	poke v 7 to lit-string! either 256 > length? license-key/Key [
		license-key/Key
	][
		copy/part license-key/Key 255
	]
	exit
]]


set 'write-LKey make function! [[
	filename		[handle!]
	/local license-key
][
	license-key: read/binary to file! to lit-string! filename
	write/binary join pref-path %LKey.txt license-key
	exit
]]


set 'load-patch make function! [[
	name	[handle!]
	ptr		[handle!]
	default	[integer!]
	/local modules
		module-types type v
][
	;print "load-patch"
	ptr: as G2500-settings ptr
	modules: copy []
	v: as [vector! sint32 16] ptr/settings
	if error? try [		; TODO this will crash, it seems
		free patch
		;patch: load either default = 1
		patch: to block! read either default = 1 [
			join %Patches/ to lit-string! name
		][
			join pref-path [%Patches/ to lit-string! name]
		]
		if patch/1 <> 'm1102 [
			patch/1: 'm1102
			;free patch/2
			;patch/2: 'none
			remove/free next patch
			insert next patch 'none
		]
		foreach [module module-setup] patch [
			if module <> 'wires [
				append modules module
				if (module-setup <> 'none) and (module-setup <> []) [
					poke v length? modules 1
				]
			]
		]
	] [
		append modules [
			m1102
			m1004t
			m1004t
			m1004t
			m1005
			m1006
			m1033
			;m1001center
			m1016
			m1006
			m1046
			m1001
			m1001
			m1001
			m1001
			m1002
			m3001
		]
	]
	module-types: [
		m1001	1001
		m1002	1002
		m1004t	1004
		m1004p	10042
		m1005	1005
		m1006	1006
		m1016	1016
		m1027	1027
		m1033	1033
		m1036	1036
		m1046	1046
		m1047	1047
		m1050	1050
		m1102	1102
		m3001	3001
	]
	v: as [vector! sint32 16] ptr/module-types
	repeat n length? modules [
		type: select module-types modules/:n
		if type [
			;v/:n: type
			poke v n type
		]
	]
	exit
]]


midi-settings: none


set 'default-settings make function! [[
	/local settings
][
	settings: read/binary %settings.txt
	write/binary join pref-path %settings.txt settings
	settings: read/binary %midi-settings.txt
	write/binary join pref-path %midi-settings.txt settings
	exit
]]


set 'default-patches make function! [[
	/local a-patch
][
	a-patch: load/all %Patches/setup
	save join pref-path %Patches/setup a-patch
	a-patch: load/all %Patches/setup-empty
	save join pref-path %Patches/setup-empty a-patch
	a-patch: load/all %Patches/setup-full
	save join pref-path %Patches/setup-full a-patch
	exit
]]


update-settings: make function! [[
	settings
	/local defaults
][
	defaults: load/all %settings.txt
	if find settings 'audio-input-device [defaults/audio-input-device: settings/audio-input-device]
	if find settings 'audio-output-device [defaults/audio-output-device: settings/audio-output-device]
	if find settings 'buffer-size [defaults/buffer-size: settings/buffer-size]
	if find settings 'MIDI-input-device [defaults/MIDI-input-device: settings/MIDI-input-device]
	if find settings 'skin [defaults/skin: mold copy settings/skin]
	if find settings 'tooltips [defaults/tooltips: settings/tooltips]
	if find settings 'zoomdial [defaults/zoomdial: settings/zoomdial]
	if find settings 'fullscreen [defaults/fullscreen: settings/fullscreen]
	if find settings 'window-pos [defaults/window-pos: settings/window-pos]
	if find settings 'window-size [defaults/window-size: settings/window-size]
	write/binary join pref-path %settings.txt form defaults
]]


set 'load-settings make function! [[
	name	[handle!]
	audio	[handle!]
	ptr		[handle!]
	/local settings
][
	audio: as audio-settings audio
	settings: load join pref-path %settings.txt
	if any [
		20 <> length? settings
	][
		update-settings settings
		settings: load join pref-path %settings.txt
	]
	audio/audio-input-device:	settings/audio-input-device
	audio/audio-output-device:	settings/audio-output-device
	audio/buffer-size:			settings/buffer-size
	audio/MIDI-input-device:	settings/MIDI-input-device
	load-patch name ptr
	midi-settings: load join pref-path %midi-settings.txt
	ptr: as G2500-settings ptr
	ptr/skin:		to lit-string! settings/skin
	ptr/tooltips:	settings/tooltips
	ptr/zoomdial:	settings/zoomdial
	ptr/fullscreen:	settings/fullscreen
	ptr/window-x:	settings/window-pos/1
	ptr/window-y:	settings/window-pos/2
	ptr/window-w:	settings/window-size/1
	ptr/window-h:	settings/window-size/2
	exit
]]


set 'save-settings make function! [[
	audio	[handle!]
	skin	[handle!]
	;tooltips	[integer!]
	;fullscreen	[integer!]
	ptr		[handle!]
	/local settings
][
	audio: as audio-settings audio
	settings: load/all join pref-path %settings.txt
	settings/audio-input-device:	audio/audio-input-device
	settings/audio-output-device:	audio/audio-output-device
	settings/buffer-size:			audio/buffer-size
	settings/MIDI-input-device:		audio/MIDI-input-device
	settings/skin:			mold to string! to lit-string! skin
	ptr: as G2500-settings ptr
	settings/tooltips:		ptr/tooltips
	settings/zoomdial:		ptr/zoomdial
	settings/fullscreen:	ptr/fullscreen
	settings/window-pos:	add 1x0 * ptr/window-x 0x1 * ptr/window-y
	settings/window-size:	add 1x0 * ptr/window-w 0x1 * ptr/window-h
	;save %settings.txt settings
	;write/binary %settings.txt form settings
	write/binary join pref-path %settings.txt form settings
	exit
]]


set 'load-midi-settings make function! [[
	type	[integer!]
	ptr		[handle!]
	/local module-types module controls
][
	module-types: [
		;m10010
		m1001
		m1002
		m1004t
		m1004p
		m1005
		m1006
		m1016
		m1027
		m1033
		m1036
		m1046
		m1047
		m1050
		m1102
		m3001
	]
	module: pick module-types type
	if controls: pick midi-settings module [
		ptr: as [vector! sint8 128] ptr
		foreach [midi-control arp-control] controls [
			poke ptr midi-control + 1 arp-control
		]
	]
	exit
]]


set 'load-module-settings make function! [[
	module	[integer!]
	n		[integer!]
	ptr		[handle!]
	/local module-settings module-types spec module-setup type id
][
	module-settings: as [vector! sint64 72] ptr
	module-types: [
		1002	%m1002.txt
		1004	%m1004t.txt
		10042	%m1004p.txt
		1005	%m1005.txt
		1006	%m1006.txt
		1016	%m1016.txt
		1027	%m1027.txt
		1033	%m1033.txt
		1036	%m1036.txt
		1046	%m1046.txt
		1047	%m1047.txt
		1050	%m1050.txt
		1102	%m1102.txt
		3001	%m3001.txt
	]
	;print ["n:" n "module-type:" select module-types module]
	spec: load join %specs/ select module-types module
	module-setup: pick patch n * 2
	foreach [setting value] module-setup [
		set/local [type id] next find spec setting
		;if (type = 1004) and (id = 27) [print value]
		poke module-settings id + 1 either type = integer! [
			value
		][	; real!
			to integer! to binary! value
		]
	]
	;update-module n select module-types modules/:n module-settings
	exit
]]


set 'load-wires make function! [[
	ptr	[handle!]
	/local m w b
][
	if patch/wires [
		ptr: as [vector! uint32 40] ptr
		m: 1
		repeat n length? patch/wires [
			w: pick patch/wires n
;			either range! = type? w [
;				poke ptr m pick w 1
;				m: m + 1
;				poke ptr m pick w 2
;			][
;				poke ptr m w
;			]
			b: to binary! w
			append/dup b #{00} 4 - length? b
			w: to integer! b
			poke ptr m w
			m: m + 1
		]
	]
	exit
]]


set 'clear-patch make function! [[
][
	clear/free patch
	;free patch
	;patch: none
	exit
]]


set 'save-module-settings make function! [[
	module	[integer!]
	ptr		[handle!]
	/local module-settings module-types module-type spec
][
	module-settings: as [vector! sint64 72] ptr
	module-types: [
		1001	m1001
		1002	m1002
		1004	m1004t
		10042	m1004p
		1005	m1005
		1006	m1006
		1016	m1016
		1027	m1027
		1033	m1033
		1036	m1036
		1046	m1046
		1047	m1047
		1050	m1050
		1102	m1102
		3001	m3001
	]
	module-type: select module-types module
	append patch reduce [
		module-type retain copy []
	]
	if module <> 0 [
		spec: load join %specs/ [module-type %.txt]
		foreach [setting type id] spec [
			append patch/2 setting
			;if (module = 1004) and (id = 27) [print [
				;type
				;pick module-settings id + 1
				;to binary! pick module-settings id + 1
				;to real! to binary! pick module-settings id + 1
			;]]
			append patch/2 either type = integer! [
				pick module-settings id + 1
			][	; real!
				to real! to binary! pick module-settings id + 1
			]
		]
		if module-type = 'm1027 [
			set-newline patch true
			patch: tail patch
			append patch [
				none none
			]
		]
	]
	set-newline patch true
	patch: tail patch
	exit
]]


set 'save-wires make function! [[
	ptr		[handle!]
	length	[integer!]
	/local b w	; n
][
	append patch reduce [
		'wires retain copy []
	]
	ptr: as [vector! uint32 40] ptr
	;n: 1
	;while [n < length] [
	repeat n length [
		;w: to range! reduce [pick ptr n pick ptr n + 1]
		;append patch/2 w
		;n: n + 2
		b: skip to binary! pick ptr n 4
		w: to tuple! reduce either b/4 = 0 [
			[b/1 b/2 b/3]
		][
			[b/1 b/2 b/3 b/4]
		]
		append patch/2 w
	]
	set-newline patch true
	patch: tail patch
	exit
]]


set 'save-patch make function! [[
	name	[handle!]
][
	patch: head patch
	save join pref-path [%Patches/ to lit-string! name] patch
	exit
]]


set 'layout-module make function! [[
	type	[integer!]
	vob		[handle!]
	/local module-types
][
	;print ["layout-module:" type]
	module-types: [
		1		%load-requester.txt
		2		%save-requester.txt
		;3		%prefs-requester.txt
		3		%prefs-devices.txt
		4		%prefs-modules.txt
		5		%prefs-general.txt
		6		%prefs-about.txt
		7		%demo-requester.txt
		1001	%m1001.txt
		1002	%m1002.txt
		1004	%m1004t.txt
		10042	%m1004p.txt
		1005	%m1005.txt
		1006	%m1006.txt
		1016	%m1016.txt
		1027	%m1027.txt
		1033	%m1033.txt
		1036	%m1036.txt
		1046	%m1046.txt
		1047	%m1047.txt
		1050	%m1050.txt
		1102	%m1102.txt
		3001	%m3001.txt
	]
	GARPview-layout
		to block! read join %modules/ select module-types type
		vob
	exit
]]


dir-info: make struct! [[
	uint32	length
	uint32	include-parent
] none]
dir: none


set 'dir-length? make function! [[
	name	[handle!]
	ptr		[handle!]
	default	[integer!]
][
	free dir
	dir: sort read either default = 1 [
		join %Patches/ to lit-string! name
	][
		join pref-path [%Patches/ to lit-string! name]
	]
	while [all [dir/1 #"." = pick dir/1 1]] [
		dir: next dir
	]
	ptr: as dir-info ptr
	if ptr/include-parent = 1 [
		insert dir retain copy "../"
	]
	ptr/length: length? dir
	exit
]]


set 'list-dir make function! [[
	v		[handle!]
	length	[integer!]
][
	v: as reduce ['vector! 'pointer length] v
	repeat n length [
		poke v n to lit-string! dir/:n
	]
	exit
]]


]	; G2500 context


